program CK5Patch;

{$A+,B+,E-,F-,G-,I-,P+,Q-,R-,S-,T-,V-,X+}
{$M 3072,0,0}

{$DEFINE KEEN5}
{$DEFINE KEEN4_ARCH}

uses Loader,Parser,Patcher,Misc,Dos,Strings;

const
    ExecutableFileSpec='KEEN5*.EXE';
    ProgramName='CK5PATCH';
    Ext='CK5';
    NumLevels=15;

type
    TDataFile=(dfGameMaps,dfEGAGraph,dfAudio);
    TDataResource=(drAudioHed,drEGAHead,drMapHead,drAudioDct,drEGADict);

    PDataResourceOffset=^TDataResourceOffset;
    TDataResourceOffset=array[Low(TDataResource)..High(TDataResource)] of Longint;

    PLevelStringLength=^TLevelStringLength;
    TLevelStringLength=array[0..NumLevels] of Word;

    PVersion=^TVersion;
    TVersion=record
        ID:String[7];
        ImageLength:Longint;
        DataResourceOffset:PDataResourceOffset;
        LevelNameOffset:Longint;
        LevelNameLength:PLevelStringLength;
        LevelEntryOffset:Longint;
        LevelEntryLength:PLevelStringLength;
    end;

const
    DataResourceOffset_14:TDataResourceOffset=
        ($21C78,$21FC0,$25990,$35EC4,$38EC4);

    LevelNameLength_14:TLevelStringLength=
        (16,32,16,32,32,32,32,32,32,32,32,32,32,16,16,16);

    LevelEntryLength_14:TLevelStringLength=
        (48,48,48,48,48,48,48,48,48,48,48,64,48,48,48,64);

    Version:array[0..0] of TVersion=(
        (
            ID:'1.4';
            ImageLength:254832;
            DataResourceOffset:@DataResourceOffset_14;
            LevelNameOffset:$20040;
            LevelNameLength:@LevelNameLength_14;
            LevelEntryOffset:$201F0;
            LevelEntryLength:@LevelEntryLength_14
        ));

{$I CKXPATCH.INC}

begin
    Main;
end.
