program CK1Patch;

{$A+,B+,E-,F-,G-,I-,P+,Q-,R-,S-,T-,V-,X+}
{$M 3072,0,0}

{$DEFINE KEEN1}
{$DEFINE KEEN1_ARCH}

uses Loader,Parser,Patcher,Misc,Dos,Strings;

const
    ExecutableFileSpec='KEEN1*.EXE';
    ProgramName='CK1PATCH';
    Ext='CK1';

type
    PHintTextGridLineSize=^THintTextGridLineSize;
    THintTextGridLineSize=array[0..44] of Byte;

    PHintTextGridLineIndex=^THintTextGridLineIndex;
    THintTextGridLineIndex=array[1..16] of Byte;

    PHintTextGridLineSpan=^THintTextGridLineSpan;
    THintTextGridLineSpan=array[1..16] of Byte;

    PVersion=^TVersion;
    TVersion=record
        ID:String[7];
        ImageLength:Longint;
        HintOffset:Longint;
        HintTextGridLineSize:PHintTextGridLineSize;
        HintTextGridLineIndex:PHintTextGridLineIndex;
        HintTextGridLineSpan:PHintTextGridLineSpan;
    end;

const
    HintTextGridLineSize_11:THintTextGridLineSize=(
        22,22,22,22,22,22,22,
        22,22,22,22,22,22,22,
        22,22,22,22,22,22,22,
        22,22,22,22,22,22,22,
        22,22,22,22,
        22,22,22,23,22,22,22,
        22,22,22,22,22,22
        );

    HintTextGridLineIndex_11:THintTextGridLineIndex=(
        $FF,0,$FF,$FF,$FF,7,$FF,$FF,14,21,28,32,$FF,$FF,39,$FF);

    HintTextGridLineSpan_11:THintTextGridLineSpan=(
        $FF,7,$FF,$FF,$FF,7,$FF,$FF,7,7,4,7,$FF,$FF,6,$FF);

    Version:array[0..1] of TVersion=(
        (
            ID:'1.1';
            ImageLength:99762;
            HintOffset:$15144;
            HintTextGridLineSize:@HintTextGridLineSize_11;
            HintTextGridLineIndex:@HintTextGridLineIndex_11;
            HintTextGridLineSpan:@HintTextGridLineSpan_11
        ),(
            ID:'1.31';
            ImageLength:99972;
            HintOffset:$15080;
            HintTextGridLineSize:@HintTextGridLineSize_11;
            HintTextGridLineIndex:@HintTextGridLineIndex_11;
            HintTextGridLineSpan:@HintTextGridLineSpan_11
        ));

{$I CKXPATCH.INC}

begin
    Main;
end.
